=== debian/changelog ===
sysdig (0.26.4-1ubuntu0.3) focal; urgency=medium

  * No change rebuild in security pocket. LP: #1914279.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 29 Apr 2021 16:09:03 +0100

sysdig (0.26.4-1ubuntu0.2) focal; urgency=medium

  * Fix dkms build on armhf (LP: #1901734)
    - 0001-UBUNTU-SAUCE-armhf-fix-64bit-mod-by-using-div64_u64_.patch

 -- Kleber Sacilotto de Souza <kleber.souza@canonical.com>  Fri, 13 Nov 2020 10:30:30 +0100

sysdig (0.26.4-1ubuntu0.1) focal; urgency=medium

  * Fix build with Linux >= 5.6 (LP: #1901734)
    - 0001-Linux-5.6-timespec-changes.patch
    - 0001-Linux-5.8-replace-probe_kernel_read-with-copy_from_k.patch

 -- Kleber Sacilotto de Souza <kleber.souza@canonical.com>  Tue, 27 Oct 2020 17:49:22 +0100

sysdig (0.26.4-1) unstable; urgency=medium

  * New upstream version 0.26.4 (Closes: #927418)
  * Refresh fix-arm64 patch.
  * Refresh luajit patch.
  * Add dep on libc-ares, protobuf, grpc
  * Bump S-V, compat; no changes needed

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Mon, 14 Oct 2019 22:50:22 -0400

sysdig (0.24.1-3) unstable; urgency=high

  * Refresh patch to fix missed #ifdef (Closes: #905929)

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Mon, 15 Apr 2019 21:55:31 -0400

sysdig (0.24.1-2) unstable; urgency=high

  * Integrate patch to fix RISC-V and arm64 FTBFS. (Closes: #905929)

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Sat, 06 Apr 2019 16:56:12 -0400
