## sysdig 0.26.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -160,6 +160,27 @@
 	set(LUAJIT_INCLUDE "${LUAJIT_SRC}")
 	if(NOT WIN32)
 		set(LUAJIT_LIB "${LUAJIT_SRC}/libluajit.a")
+ 		if("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "ppc64le")
+		ExternalProject_Add(luajit
+			GIT_REPOSITORY "https://github.com/moonjit/moonjit"
+			GIT_TAG "2.1.2"
+			PATCH_COMMAND sed -i "s/luaL_reg/luaL_Reg/g" ${PROJECT_SOURCE_DIR}/userspace/libsinsp/chisel.cpp && sed -i "s/luaL_reg/luaL_Reg/g" ${PROJECT_SOURCE_DIR}/userspace/libsinsp/lua_parser.cpp && sed -i "s/luaL_getn/lua_objlen /g" ${PROJECT_SOURCE_DIR}/userspace/libsinsp/lua_parser_api.cpp
+			CONFIGURE_COMMAND ""
+			BUILD_COMMAND ${CMD_MAKE}
+			BUILD_IN_SOURCE 1
+			BUILD_BYPRODUCTS ${LUAJIT_LIB}
+			INSTALL_COMMAND "")
+		elseif("${CMAKE_SYSTEM_PROCESSOR}" STREQUAL "s390x")
+                ExternalProject_Add(luajit
+                        GIT_REPOSITORY "https://github.com/linux-on-ibm-z/LuaJIT.git"
+                        GIT_TAG "v2.1"
+                        PATCH_COMMAND sed -i "s/luaL_reg/luaL_Reg/g" ${PROJECT_SOURCE_DIR}/userspace/libsinsp/chisel.cpp && sed -i "s/luaL_reg/luaL_Reg/g" ${PROJECT_SOURCE_DIR}/userspace/libsinsp/lua_parser.cpp && sed -i "s/luaL_getn/lua_objlen /g" ${PROJECT_SOURCE_DIR}/userspace/libsinsp/lua_parser_api.cpp
+                        CONFIGURE_COMMAND ""
+                        BUILD_COMMAND ${CMD_MAKE}
+                        BUILD_IN_SOURCE 1
+                        BUILD_BYPRODUCTS ${LUAJIT_LIB}
+                        INSTALL_COMMAND "")		
+		else()
 		ExternalProject_Add(luajit
 			URL "http://download.draios.com/dependencies/LuaJIT-2.0.3.tar.gz"
 			URL_MD5 "f14e9104be513913810cd59c8c658dc0"
@@ -168,6 +189,7 @@
 			BUILD_IN_SOURCE 1
 			BUILD_BYPRODUCTS ${LUAJIT_LIB}
 			INSTALL_COMMAND "")
+		endif()
 	else()
 		set(LUAJIT_LIB "${LUAJIT_SRC}/lua51.lib")
 		ExternalProject_Add(luajit
@@ -323,51 +345,3 @@
 		ExternalProject_Add(ncurses
 			URL "http://download.draios.com/dependencies/ncurses-6.0-20150725.tgz"
 			URL_MD5 "32b8913312e738d707ae68da439ca1f4"
-			CONFIGURE_COMMAND ./configure --without-cxx --without-cxx-binding --without-ada --without-manpages --without-progs --without-tests --with-terminfo-dirs=/etc/terminfo:/lib/terminfo:/usr/share/terminfo
-			BUILD_COMMAND ${CMD_MAKE}
-			BUILD_IN_SOURCE 1
-			BUILD_BYPRODUCTS ${CURSES_LIBRARIES}
-			INSTALL_COMMAND "")
-	endif()
-endif()
-
-if(NOT WIN32 AND NOT APPLE)
-	#
-	# libb64
-	#
-	option(USE_BUNDLED_B64 "Enable building of the bundled b64" ${USE_BUNDLED_DEPS})
-
-	if(NOT USE_BUNDLED_B64)
-		find_path(B64_INCLUDE NAMES b64/encode.h)
-		find_library(B64_LIB NAMES b64)
-		if(B64_INCLUDE AND B64_LIB)
-			message(STATUS "Found b64: include: ${B64_INCLUDE}, lib: ${B64_LIB}")
-		else()
-			message(FATAL_ERROR "Couldn't find system b64")
-		endif()
-	else()
-		set(B64_SRC "${PROJECT_BINARY_DIR}/b64-prefix/src/b64")
-		message(STATUS "Using bundled b64 in '${B64_SRC}'")
-		set(B64_INCLUDE "${B64_SRC}/include")
-		set(B64_LIB "${B64_SRC}/src/libb64.a")
-		ExternalProject_Add(b64
-			URL "http://download.draios.com/dependencies/libb64-1.2.src.zip"
-			URL_MD5 "a609809408327117e2c643bed91b76c5"
-			CONFIGURE_COMMAND ""
-			BUILD_COMMAND ${CMD_MAKE}
-			BUILD_IN_SOURCE 1
-			BUILD_BYPRODUCTS ${B64_LIB}
-			INSTALL_COMMAND "")
-	endif()
-endif()
-
-if(NOT WIN32)
-	#
-	# OpenSSL
-	#
-	option(USE_BUNDLED_OPENSSL "Enable building of the bundled OpenSSL" ${USE_BUNDLED_DEPS})
-
-	if(NOT USE_BUNDLED_OPENSSL)
-		find_package(OpenSSL REQUIRED)
-		message(STATUS "Found OpenSSL: include: ${OPENSSL_INCLUDE_DIR}, lib: ${OPENSSL_LIBRARIES}")
-	else()
