=== userspace/libsinsp/CMakeLists.txt ===
--- 
+++ 
@@ -19,9 +19,9 @@
 include_directories(../../common)
 include_directories(../libscap)
 include_directories(../async)
+include_directories(./include)
 include_directories("${JSONCPP_INCLUDE}")
 include_directories("${LUAJIT_INCLUDE}")
-include_directories("${TBB_INCLUDE_DIR}")
 
 if(NOT WIN32 AND NOT APPLE)
 	include_directories("${B64_INCLUDE}")
@@ -34,6 +34,7 @@
 endif()
 
 if(NOT WIN32)
+	include_directories("${TBB_INCLUDE_DIR}")
 	include_directories("${CURL_INCLUDE_DIR}")
 endif()
 
@@ -41,7 +42,7 @@
 	chisel.cpp
 	chisel_api.cpp
 	container.cpp
-	container_engine/container_engine.cpp
+	container_engine/container_engine_base.cpp
 	container_engine/docker_common.cpp
 	container_info.cpp
 	ctext.cpp
@@ -134,11 +135,13 @@
 
 if(NOT WIN32 AND NOT APPLE)
 list(APPEND SINSP_SOURCES
-	grpc_channel_registry.cpp
+	cgroup_limits.cpp
 	cri.cpp
 	container_engine/cri.cpp
 	${CMAKE_CURRENT_BINARY_DIR}/cri.grpc.pb.cc
-	${CMAKE_CURRENT_BINARY_DIR}/cri.pb.cc)
+	${CMAKE_CURRENT_BINARY_DIR}/cri.pb.cc
+	grpc_channel_registry.cpp
+)
 endif()
 
 add_library(sinsp STATIC ${SINSP_SOURCES})
