=== debian/changelog ===
sysdig (0.26.7-2ubuntu3) hirsute; urgency=medium

  * Rebuild against new libjsoncpp24.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 07 Dec 2020 15:28:07 +0100

sysdig (0.26.7-2ubuntu2) groovy; urgency=medium

  * Fix FTBFS on armhf

 -- Paolo Pisati <paolo.pisati@canonical.com>  Thu, 13 Aug 2020 15:27:49 +0000

sysdig (0.26.7-2ubuntu1) groovy; urgency=medium

  * Fix FTBFS with Linux 5.8

 -- Paolo Pisati <paolo.pisati@canonical.com>  Wed, 05 Aug 2020 11:30:36 +0000

sysdig (0.26.7-2build1) groovy; urgency=medium

  * Rebuild against new libprotobuf23.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 26 Jul 2020 10:24:51 +0200

sysdig (0.26.7-2) unstable; urgency=medium

  * Fix FTBFS on mips architecture. 

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Sun, 07 Jun 2020 00:47:34 -0400

sysdig (0.26.7-1) unstable; urgency=medium

  * New upstream version 0.26.7 (Closes: #955279, #946463, #958643)
  * Refresh patches.
  * Add dep on libgtest-dev
  * Switch to debhelper-compat, dh 13
  * Bump S-V; no changes needed
  * Make dh-missing happy

 -- Harlan Lieberman-Berg <hlieberman@debian.org>  Wed, 03 Jun 2020 22:02:05 -0400
